/* -*- buffer-read-only: t -*- vi: set ro:
#line 636
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
#line 636
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>

static size_t debug_handle;
/* This must be defined before including debug.h */
#define MF_SOURCE_NAME  debug_handle

#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 15 "spf.bi"
/* This file is part of Mailfromd.             -*- c -*-
#line 15
   Copyright (C) 2007-2008, 2010-2011 Sergey Poznyakoff
#line 15

#line 15
   This program is free software; you can redistribute it and/or modify
#line 15
   it under the terms of the GNU General Public License as published by
#line 15
   the Free Software Foundation; either version 3, or (at your option)
#line 15
   any later version.
#line 15

#line 15
   This program is distributed in the hope that it will be useful,
#line 15
   but WITHOUT ANY WARRANTY; without even the implied warranty of
#line 15
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#line 15
   GNU General Public License for more details.
#line 15

#line 15
   You should have received a copy of the GNU General Public License
#line 15
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "spf.h"

static size_t spf_explanation_loc
#line 19 "spf.bi"
;
static size_t spf_mechanism_loc
#line 20 "spf.bi"
;
static size_t spf_ttl_loc
#line 21 "spf.bi"
;
static size_t spf_explanation_prefix_loc
#line 22 "spf.bi"
;
       
static void
update_spf_vars(eval_environ_t env, spf_answer_t *ans)
{
	
#line 27
{ size_t __off;
#line 27
  const char *__s = ans->exp_text;
#line 27
  if (__s)
#line 27
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 27
  else
#line 27
     __off = 0;
#line 27
  *env_data_ref(env, spf_explanation_loc) = (STKVAL) (__off); }
#line 27
;
	
#line 28
{ size_t __off;
#line 28
  const char *__s = ans->mech;
#line 28
  if (__s)
#line 28
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 28
  else
#line 28
     __off = 0;
#line 28
  *env_data_ref(env, spf_mechanism_loc) = (STKVAL) (__off); }
#line 28
;
	*env_data_ref(env, spf_ttl_loc) = (STKVAL) (ans->ttl);
}

void
#line 32
bi_spf_check_host(eval_environ_t env)
#line 32

#line 32 "spf.bi"
{
#line 32
	
#line 32

#line 32

#line 32
char * ip;
#line 32
        char * domain;
#line 32
        char * sender;
#line 32
        char * helo_domain;
#line 32
        char * my_domain;
#line 32
        
#line 32
get_string_arg(env, 0, &ip);
#line 32
        get_string_arg(env, 1, &domain);
#line 32
        get_string_arg(env, 2, &sender);
#line 32
        get_string_arg(env, 3, &helo_domain);
#line 32
        get_string_arg(env, 4, &my_domain);
#line 32
        
#line 32

#line 32
        adjust_stack(env, 5);
#line 32

#line 32
	if (builtin_module_trace(BUILTIN_IDX_spf))
#line 32
		prog_trace(env, "spf_check_host %s %s %s %s %s",ip, domain, sender, helo_domain, my_domain);;

{
	spf_result res;
	spf_query_t q;
	spf_answer_t ans;

	q.ipstr = ip;
	q.domain = domain;
	q.sender = sender;
	q.helo_domain = helo_domain;
	q.my_domain = my_domain;
	q.exp_prefix = *env_data_ref(env, spf_explanation_prefix_loc) ;
	res = spf_check_host(&q, &ans);
	update_spf_vars(env, &ans);
	spf_answer_free(&ans);
	
#line 48
do {
#line 48
  push(env, (STKVAL) (res));
#line 48
  return;
#line 48
} while (0);
}
}

void
#line 52
bi_spf_test_record(eval_environ_t env)
#line 52

#line 52 "spf.bi"
{
#line 52
	
#line 52

#line 52

#line 52
char * record;
#line 52
        char * ip;
#line 52
        char * domain;
#line 52
        char * sender;
#line 52
        char * helo_domain;
#line 52
        char * my_domain;
#line 52
        
#line 52
get_string_arg(env, 0, &record);
#line 52
        get_string_arg(env, 1, &ip);
#line 52
        get_string_arg(env, 2, &domain);
#line 52
        get_string_arg(env, 3, &sender);
#line 52
        get_string_arg(env, 4, &helo_domain);
#line 52
        get_string_arg(env, 5, &my_domain);
#line 52
        
#line 52

#line 52
        adjust_stack(env, 6);
#line 52

#line 52
	if (builtin_module_trace(BUILTIN_IDX_spf))
#line 52
		prog_trace(env, "spf_test_record %s %s %s %s %s %s",record, ip, domain, sender, helo_domain, my_domain);;
#line 54

{
	spf_result res;
	spf_query_t q;
	spf_answer_t ans;

	q.ipstr = ip;
	q.domain = domain;
	q.sender = sender;
	q.helo_domain = helo_domain;
	q.my_domain = my_domain;
	q.exp_prefix = *env_data_ref(env, spf_explanation_prefix_loc) ;
	res = spf_test_record(record, &q, &ans);
	update_spf_vars(env, &ans);
	spf_answer_free(&ans);
	
#line 69
do {
#line 69
  push(env, (STKVAL) (res));
#line 69
  return;
#line 69
} while (0);
}
}


#line 73
void
#line 73
spf_init_builtin()
#line 73
{
#line 73
        debug_handle = debug_register("bi_spf");
#line 73
	#line 19 "spf.bi"
	builtin_variable_install("spf_explanation", dtype_string, SYM_VOLATILE, &spf_explanation_loc);
#line 20 "spf.bi"
	builtin_variable_install("spf_mechanism", dtype_string, SYM_VOLATILE, &spf_mechanism_loc);
#line 21 "spf.bi"
	builtin_variable_install("spf_ttl", dtype_number, SYM_VOLATILE, &spf_ttl_loc);
#line 22 "spf.bi"
	builtin_variable_install("spf_explanation_prefix", dtype_string, SYM_VOLATILE, &spf_explanation_prefix_loc);
#line 32 "spf.bi"
va_builtin_install_ex("spf_check_host", bi_spf_check_host, 0, dtype_number, 5, 0, 0|0, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string);
#line 52 "spf.bi"
va_builtin_install_ex("spf_test_record", bi_spf_test_record, 0, dtype_number, 6, 0, 0|0, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string, dtype_string);

#line 73 "spf.bi"
	
#line 73
}
#line 73

#line 627 "../../mfd/builtin/snarf.m4"

#line 627

